

-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_LoadBoneAnim"

-- **************************************************
-- General information about this script
-- **************************************************

DS_LoadBoneAnim = {}

function DS_LoadBoneAnim:Name()
	return "Load bone animation"
end

function DS_LoadBoneAnim:Version()
	return "0.5"
end

function DS_LoadBoneAnim:Description()
	return "Load bone animation"
end

function DS_LoadBoneAnim:Creator()
	return "dauid.com"
end

function DS_LoadBoneAnim:UILabel()
	return("Load bone animation")
end

--************************menu
local DS_Dialog = {}

DS_Dialog.UPDATE = MOHO.MSG_BASE

function DS_Dialog:new(moho)
	local d = LM.GUI.SimpleDialog("Settings", DS_Dialog)
	local l = d:GetLayout()

	d.moho = moho


	angleBox = LM.GUI.CheckBox("Import bone rotation")
	l:AddChild(angleBox, LM.GUI.ALIGN_LEFT)	
	angleBox:SetValue(true)
	
	relangleBox = LM.GUI.CheckBox("Relative rotations")
	l:AddChild(relangleBox, LM.GUI.ALIGN_LEFT)	
	relangleBox:SetValue(true)
	
	posBox = LM.GUI.CheckBox("Import bone positions")
	l:AddChild(posBox, LM.GUI.ALIGN_LEFT)	
	posBox:SetValue(true)
	
	relaBox = LM.GUI.CheckBox("Relative positions")
	l:AddChild(relaBox, LM.GUI.ALIGN_LEFT)	
	relaBox:SetValue(true)
	
	scaleBox = LM.GUI.CheckBox("Import bone scale")
	l:AddChild(scaleBox, LM.GUI.ALIGN_LEFT)	
	scaleBox:SetValue(true)
	
	lockBox = LM.GUI.CheckBox("Import locked frames")
	l:AddChild(lockBox, LM.GUI.ALIGN_LEFT)	
	lockBox:SetValue(true)
	
	flipBox = LM.GUI.CheckBox("Flip X (Only works with relative angles and position)")
	l:AddChild(flipBox, LM.GUI.ALIGN_LEFT)	



	return d
end


function DS_Dialog:OnOK()
angleBox=angleBox:Value()
relangleBox=relangleBox:Value()
posBox=posBox:Value()
relaBox=relaBox:Value()
flipBox=flipBox:Value()
scaleBox=scaleBox:Value()
lockBox=lockBox:Value()

end


-- **************************************************
-- The guts of this script
-- **************************************************


function DS_LoadBoneAnim:IsEnabled(moho)

	if (moho.layer:LayerType() ~= MOHO.LT_BONE) then --If a bone layer is not selected, disable the script
		return false
	end
skel = moho:Skeleton()
	if (skel == nil) then
			return false
	end
	
	return true
end


function DS_LoadBoneAnim:Run(moho)

local dlog = DS_Dialog:new(moho)
	if (dlog:DoModal() == LM.GUI.MSG_CANCEL) then
		return
	end


local path = LM.GUI.OpenFile("Select Data File")
	if (path == "") then
		return
	end

	local f = io.open(path, "r")
	if (f == nil) then
		return
	end
	
startFrame = moho.document:StartFrame()
endFrame = moho.document:EndFrame()
skel = moho:Skeleton()
local cmd = f:read()
BoneTable={}
	while (cmd ~= nil) do --While there is still stuff in the loaded file
		if (string.sub(cmd, 1, 5) == "Bone:") then --If the current line in the file says "Bone:"
		loadedBoneName = f:read("*l") --Save the bone name read from the file
			for i = 0, skel:CountBones() - 1 do --For every bone do this
			theBone=skel:Bone(i)
			originalBoneName=theBone:Name()
				if (loadedBoneName==originalBoneName)then --If the loaded bone name has a namesake in the file
					
					
					-------------------------------------------------------------------Load bone angle (rotation)
					local numKeys
					loadedNum=f:read("*n")--First read how many keyframes there are
					local loadedFrames={}
					local loadedValues={}
					local valueDiff, newValue
					
					if (angleBox==true) and (relangleBox==true) then
							for numKeys=1, loadedNum do
							table.insert(loadedFrames, f:read("*n"))
							table.insert(loadedValues, f:read("*n"))
							valueDiff=loadedValues[numKeys]-loadedValues[1]
								if (flipBox==true) then
								newValue=theBone.fAnimAngle:GetValue(loadedFrames[1])-valueDiff
								else
								newValue=theBone.fAnimAngle:GetValue(loadedFrames[1])+valueDiff
								end
							theBone.fAnimAngle:SetValue(loadedFrames[numKeys], newValue)
		
							end
							
					elseif (angleBox==true) and (relangleBox==true) then
							for numKeys=1, loadedNum do
							table.insert(loadedFrames, f:read("*n"))
							table.insert(loadedValues, f:read("*n"))
							valueDiff=loadedValues[numKeys]-loadedValues[1]
							newValue=theBone.fAnimAngle:GetValue(loadedFrames[1])-valueDiff
							theBone.fAnimAngle:SetValue(loadedFrames[numKeys], newValue)
		
							end
							
					elseif (angleBox==true) and (relangleBox==false) then
							for numKeys=1, loadedNum do
								theBone.fAnimAngle:SetValue(f:read("*n"), f:read("*n"))
		
							end
					else
					
							for numKeys=1, loadedNum do
								local null=(f:read("*n")..f:read("*n"))
		
							end
					end
					
------------------------------------------------------------------------------------------Load bone position
					
					loadedNum=f:read("*n") --First read how many keyframes there are
					local vec=LM.Vector2:new_local() 
					local vecb=LM.Vector2:new_local()
					local vecc=LM.Vector2:new_local()
					local loadedX={}
					local loadedY={}
					
					if (posBox==true) and (relaBox==true) then --Relabox is a checkbox for relative values
							loadedFrames={} --Clear the table so we can use it again

							for numKeys=1, loadedNum do
							table.insert(loadedFrames, f:read("*n")) 	--Insert all frame values in a table
							table.insert(loadedX, f:read("*n")) 		--Insert all X values in a table
							table.insert(loadedY, f:read("*n")) 		--Insert all Y values in a table
							vec.x=(loadedX[numKeys]-loadedX[1])			--Subtract every X value with the first X value so we only get the difference (the very first value will then be 0)
							vec.y=(loadedY[numKeys]-loadedY[1]) 		--Subtract every Y value with the first Y value so we only get the difference
							vecb=theBone.fAnimPos:GetValue(loadedFrames[1]) --Get the first position of the target bone (the position on the first loaded frame)
								if (flipBox==true) then
								vecc.x=vecb.x-vec.x -- Subtract difference from vecb to vecc (this will be the final position)
								else
								vecc.x=vecb.x+vec.x -- Add the difference from vecb to vecc (this will be the final position)
								end
							vecc.y=vecb.y+vec.y -- Do the same for Y
							theBone.fAnimPos:SetValue(loadedFrames[numKeys], vecc) --And set the position
							end
							
							
							
					elseif (posBox==true) and (relaBox==false) then
							for numKeys=1, loadedNum do
							frame=f:read("*n")
							vec.x=f:read("*n")
							vec.y=f:read("*n")
							theBone.fAnimPos:SetValue(frame, vec)
							end
					else
						for numKeys=1, loadedNum do
						local null=(f:read("*n")..f:read("*n")..f:read("*n"))
						end
					end
					
					-------------------------------------------------------------------Load locked frames for the bone
					local numKeys
					loadedNum=f:read("*n")--First read how many keyframes there are
					local lock, framenr
							
					if (lockBox==true) then
							for numKeys=1, loadedNum do
								framenr=f:read("*n")
								lock=f:read("*n")
								if (lock==0) then
								theBone.fIKLock:SetValue(framenr, false)
								else
								theBone.fIKLock:SetValue(framenr, true)
								end
							end
					else
					
							for numKeys=1, loadedNum do
								local null=(f:read("*n")..f:read("*n"))
		
							end
					end
					
					-------------------------------------------------------------------Load bone scale
					loadedNum=f:read("*n")--First read how many keyframes there are

					if (scaleBox==true) then
							for numKeys=1, loadedNum do
								theBone.fAnimScale:SetValue(f:read("*n"), f:read("*n"))
		
							end
					else
					
							for numKeys=1, loadedNum do
								local null=(f:read("*n")..f:read("*n"))
		
							end
					end
					
					
					
					
					
				end
				
			end
		
		end
		cmd = f:read()
	end
	
	f:close() --Close the file

end
